
From: Kurt Garloff <garloff@suse.de>

when calling

alarm(1); alarm(0);

the second alarm can wrongly return 2. This makes an LSB test fail.

It happens due to rounding errors in the timeval to jiffie conversion and
back.  On i386 with HZ =3D=3D 1000, there would not need to be rounding
error IMVHO, but they even occur there.  On HZ=3D1024 platforms, they may
even be unavoidable.

Attached patch fixes the return value of alarm().


---

 25-akpm/kernel/timer.c |    2 +-
 1 files changed, 1 insertion(+), 1 deletion(-)

diff -puN kernel/timer.c~sys_alarm-retval-fix kernel/timer.c
--- 25/kernel/timer.c~sys_alarm-retval-fix	Fri Feb 27 15:58:04 2004
+++ 25-akpm/kernel/timer.c	Fri Feb 27 15:58:04 2004
@@ -867,7 +867,7 @@ asmlinkage unsigned long sys_alarm(unsig
 	oldalarm = it_old.it_value.tv_sec;
 	/* ehhh.. We can't return 0 if we have an alarm pending.. */
 	/* And we'd better return too much than too little anyway */
-	if (it_old.it_value.tv_usec)
+	if ((!oldalarm && it_old.it_value.tv_usec) || it_old.it_value.tv_usec >= 500000)
 		oldalarm++;
 	return oldalarm;
 }

_
